// =======================================================================
//  This software is the property of Precise Automation and can be freely
//  copied and used by Precise's customers so long as this notice is
//  included with any modified or unmodified version of this software.
// =======================================================================

/* Set of functions used to automatically scan and update the jog panel information
*/
	var xmlHttpJogStt
	var timesJogStt = setInterval("updatePosition()",1000);
	var jogBusy = false
	var jogUpdate = true
	
	function updatePosition(){
		if(jogUpdate==true){
			if(jogBusy==false){		
				jogBusy = true;
				xmlHttpJogStt=new ActiveXObject("Microsoft.XMLHTTP")
				var url="jogrefresh.asp";
				xmlHttpJogStt.onreadystatechange=stateChangeJogStt
				xmlHttpJogStt.open("GET",url,true)
				xmlHttpJogStt.setRequestHeader( "If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT" );
				xmlHttpJogStt.send(null)
			}
		}
		//else alert("busy");
	}
	
	function stateChangeJogStt(){
		if (xmlHttpJogStt.readyState==4 || xmlHttpJogStt.readyState=="complete"){
			var jInfo = new Array();
			jInfo = xmlHttpJogStt.responseText.split("|")
			//alert(stt2);
			//	alert(jInfo.length);
				updateJogInfo(jInfo);
				jogBusy = false;
				
		}
	}

function updateJogInfo(jData){
	//  retrieve X,Y,Z,Rx,Ry,Rz values
	//  and update the values in the right hand frame (table)

		//alert("updateJogInfo()");
		// return a reference to the right hand table.
		var ctable = document.getElementById("tblStt")
		//alert(ctable + jData);
		if (ctable != null){
		
			// set the jog mode of the panel
			//alert("wait");
			if (setAxisSelect != null){
				var allowJog=jData[20];	//<% aspRDB(215,-1,0,0,0); %>;
	
				if(allowJog){
					setJmode(jData[21]);
				}
				else {setJmode(0);}
			} //end if
	
			var errTable = parent.frameMain.document.getElementById("lastError")
			var pStateIdx = jData[22]	// Convert po
			parent.frameMain.pwrState = pStateIdx;
			updateState(pStateIdx,0)
			
			if (errTable != null){
	
				var errDesc = jData[23]
					// update the parent document flag so it can be looked at locally
	
				if(errDesc!=""){
					errTable.bgColor="yellow"
				}
				else{
					errTable.bgColor=""
				}
				errTable.rows[0].cells[0].innerHTML= errDesc
	
			} //end if
			
			// return a reference to the right hand table.
			var ctable = document.getElementById("tblJoint")
			
						// update X,Y,Z,y,p,r
			ctable.rows[0].cells[0].innerHTML = "X:"+jData[0];	//3506,1
			ctable.rows[0].cells[1].innerHTML = "Y:"+jData[1];	//3506,2
			ctable.rows[0].cells[2].innerHTML = "Z:"+jData[2];	//3506,3
			ctable.rows[0].cells[3].innerHTML = "R:"+jData[5];	//3506,6
	
			
			// loop through and update any free modes
			var freeMask = jData[18]*1;	//3525
			
			var binStr = freeMask.toString(2)
			var sMax = binStr.length-1
			//alert(binStr);
			for(i=0;i<binStr.length;i++){
				if (binStr.charAt(i) == "1"){
					if (i<6){
						ctable.rows[0].cells[sMax-i].bgColor = "yellow";
						
					}
					else{
					//	ctable.rows[0].cells[i-6].bgColor = "yellow";
					}
				} //end if
				else{
					if (i<6){
						ctable.rows[0].cells[sMax-i].bgColor = "#BABAC9";
					}
					else{
					//	ctable.rows[0].cells[i-6].bgColor = "";
					}
				} //end else
				
			} // end for
			
			// erase the remaining to no background color
			for(i=binStr.length;i<6;i++){
				if (i<4){
					ctable.rows[0].cells[i].bgColor = "#BABAC9";
				}
			} //en
	
	} //end if		

} //end function

function updateState(pStateIdx,homeStt){
	var StateTab = document.getElementById("tblStt")
	var pState = new Array(60)
	var pColor = new Array(60)

	pState[0] = "System initializing"
	pColor[0] = "White"
	pState[1] = "Fatal error"
	pColor[1] = "Red"
	pState[2] = "Restarting"
	pColor[2] = "White"
	pState[3] = "Turning off power"
	pColor[3] = "Yellow"
	pState[4] = "Turning off power"
	pColor[4] = "Yellow"
	pState[5] = "Off: fault occurred"
	pColor[5] = "Red"
	pState[6] = "Off: switch off wait"
	pColor[6] = "White"
	pState[7] = "Off: switch on wait"
	pColor[7] = "White"
	pState[8] = "Enabling power #1"
	pColor[8] = "Yellow"
	pState[9] = "Commutating motors"
	pColor[9] = "Yellow"
	pState[10] = "Enabling power #2"
	pColor[10] = "Yellow"
	pState[11] = "On: auto mode wait"
	pColor[11] = "Aqua"
	pState[12] = "On: auto mode run"
	pColor[12] = "lightgreen"
	pState[15] = "E-stop asserted"
	pColor[15] = "Red"
	pState[20] = "GPL ready"
	pColor[20] = "Aqua"
	pState[21] = "GPL executing"
	pColor[21] = "lightgreen"
	pState[22] = "MotionBlocks exec"
	pColor[22] = "lightgreen"
	pState[23] = "AIO velocity exec "
	pColor[23] = "lightgreen"
	pState[24] = "AIO torque exec   "
	pColor[24] = "lightgreen"
	pState[25] = "Master/slave exec"
	pColor[25] = "lightgreen"
	pState[26] = "CAN net executing"
	pColor[26] = "lightgreen"
	pState[27] = "CAN serial exec"
	pColor[27] = "lightgreen"
	pState[28] = "Robot Homing"
	pColor[28] = "Yellow"
	pState[29] = "Jog Mode Active"
	pColor[29] = "Yellow"
	pState[30] = "Ext traj exec"
	pColor[30] = "lightgreen"
	pState[31] = "MCP Active"
	pColor[31] = "white"
	
	StateTab.rows[0].cells[2].innerHTML = pState[pStateIdx];
	StateTab.rows[0].cells[2].bgColor=pColor[pStateIdx];
	StateTab.rows[0].cells[2].className="sBorderLocal";
	StateTab.rows[0].cells[2].style.textAlign="center";

//	StateTab.rows[1].cells[2].innerHTML = homeStt;
//	StateTab.rows[1].cells[2].style.textAlign="center";
	
}